#! /usr/bin/env python
# Copyright (C) 2007 Red Hat 
# see file 'COPYING' for use and warranty information
#
# policygentool is a tool for the initial generation of SELinux policy
#
#    This program is free software; you can redistribute it and/or
#    modify it under the terms of the GNU General Public License as
#    published by the Free Software Foundation; either version 2 of
#    the License, or (at your option) any later version.
#
#    This program is distributed in the hope that it will be useful,
#    but WITHOUT ANY WARRANTY; without even the implied warranty of
#    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#    GNU General Public License for more details.
#
#    You should have received a copy of the GNU General Public License
#    along with this program; if not, write to the Free Software
#    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA     
#                                        02111-1307  USA
#
#  
########################### Type Enforcement File #############################
te_daemon_types="""\
policy_module(TEMPLATETYPE,1.0.0)

########################################
#
# Declarations
#

type TEMPLATETYPE_t;
type TEMPLATETYPE_exec_t;
domain_type(TEMPLATETYPE_t)
init_daemon_domain(TEMPLATETYPE_t, TEMPLATETYPE_exec_t)
"""

te_inetd_types="""\
policy_module(TEMPLATETYPE,1.0.0)

########################################
#
# Declarations
#

type TEMPLATETYPE_t;
type TEMPLATETYPE_exec_t;
inetd_service_domain(TEMPLATETYPE_t, TEMPLATETYPE_exec_t)
"""

te_userapp_types="""\
policy_module(TEMPLATETYPE,1.0.0)

########################################
#
# Declarations
#

type TEMPLATETYPE_exec_t;
corecmd_executable_file(TEMPLATETYPE_exec_t)
"""

te_cgi_types="""\
policy_module(TEMPLATETYPE,1.0.0)

########################################
#
# Declarations
#

apache_content_template(TEMPLATETYPE)
"""

te_daemon_rules="""
########################################
#
# TEMPLATETYPE local policy
#

# Init script handling
domain_use_interactive_fds(TEMPLATETYPE_t)

## internal communication is often done using fifo and unix sockets.
allow TEMPLATETYPE_t self:fifo_file rw_file_perms;
allow TEMPLATETYPE_t self:unix_stream_socket create_stream_socket_perms;

files_read_etc_files(TEMPLATETYPE_t)

libs_use_ld_so(TEMPLATETYPE_t)
libs_use_shared_libs(TEMPLATETYPE_t)

miscfiles_read_localization(TEMPLATETYPE_t)

ifdef(`targeted_policy',`
	term_dontaudit_use_unallocated_ttys(TEMPLATETYPE_t)
	term_dontaudit_use_generic_ptys(TEMPLATETYPE_t)
')

"""

te_inetd_rules="""
"""

te_userapp_rules="""
"""

te_cgi_rules="""
"""

te_uid_rules="""
auth_use_nsswitch(TEMPLATETYPE_t)
"""

te_syslog_rules="""
logging_send_syslog_msg(TEMPLATETYPE_t)
"""

te_pam_rules="""
auth_domtrans_chk_passwd(TEMPLATETYPE_t)
"""

########################### Interface File #############################
if_rules="""
## <summary>policy for TEMPLATETYPE</summary>

########################################
## <summary>
##	Execute a domain transition to run TEMPLATETYPE.
## </summary>
## <param name=\"domain\">
## <summary>
##	Domain allowed to transition.
## </summary>
## </param>
#
interface(`TEMPLATETYPE_domtrans',`
	gen_require(`
		type TEMPLATETYPE_t, TEMPLATETYPE_exec_t;
	')

	domain_auto_trans($1,TEMPLATETYPE_exec_t,TEMPLATETYPE_t)

	allow TEMPLATETYPE_t $1:fd use;
	allow TEMPLATETYPE_t $1:fifo_file rw_file_perms;
	allow TEMPLATETYPE_t $1:process sigchld;
')
"""

########################### File Context ##################################
fc_file="""\

EXECUTABLE		--	gen_context(system_u:object_r:TEMPLATETYPE_exec_t,s0)
"""

