# Copyright (C) 2007 Red Hat 
# see file 'COPYING' for use and warranty information
#
# policygentool is a tool for the initial generation of SELinux policy
#
#    This program is free software; you can redistribute it and/or
#    modify it under the terms of the GNU General Public License as
#    published by the Free Software Foundation; either version 2 of
#    the License, or (at your option) any later version.
#
#    This program is distributed in the hope that it will be useful,
#    but WITHOUT ANY WARRANTY; without even the implied warranty of
#    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#    GNU General Public License for more details.
#
#    You should have received a copy of the GNU General Public License
#    along with this program; if not, write to the Free Software
#    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA     
#                                        02111-1307  USA
#
#  
########################### var_log Template File #############################

########################### Type Enforcement File #############################
te_types="""
type TEMPLATETYPE_log_t;
logging_log_file(TEMPLATETYPE_log_t)
"""

te_rules="""
allow TEMPLATETYPE_t TEMPLATETYPE_log_t:file manage_file_perms;
allow TEMPLATETYPE_t TEMPLATETYPE_log_t:dir { rw_dir_perms setattr };
logging_log_filetrans(TEMPLATETYPE_t,TEMPLATETYPE_log_t,{ file dir })
"""

########################### Interface File #############################
if_rules="""
########################################
## <summary>
##	Allow the specified domain to read TEMPLATETYPE's log files.
## </summary>
## <param name="domain">
##	<summary>
##	Domain allowed access.
##	</summary>
## </param>
## <rolecap/>
#
interface(`TEMPLATETYPE_read_log',`
	gen_require(`
		type TEMPLATETYPE_log_t;
	')

	logging_search_logs($1)
	allow $1 TEMPLATETYPE_log_t:dir r_dir_perms;
	allow $1 TEMPLATETYPE_log_t:file { read getattr lock };
')

########################################
## <summary>
##	Allow the specified domain to append
##	TEMPLATETYPE log files.
## </summary>
## <param name="domain">
## 	<summary>
##	Domain allowed to transition.
## 	</summary>
## </param>
#
interface(`TEMPLATETYPE_append_log',`
	gen_require(`
		type var_log_t, TEMPLATETYPE_log_t;
	')

	logging_search_logs($1)
	allow $1 TEMPLATETYPE_log_t:dir r_dir_perms;
	allow $1 TEMPLATETYPE_log_t:file { getattr append };
')

"""

########################### File Context ##################################
fc_file="""\
FILENAME		--	gen_context(system_u:object_r:TEMPLATETYPE_log_t,s0)
"""

fc_dir="""\
FILENAME(/.*)?			gen_context(system_u:object_r:TEMPLATETYPE_log_t,s0)
"""
