# Copyright (C) 2007 Red Hat 
# see file 'COPYING' for use and warranty information
#
# policygentool is a tool for the initial generation of SELinux policy
#
#    This program is free software; you can redistribute it and/or
#    modify it under the terms of the GNU General Public License as
#    published by the Free Software Foundation; either version 2 of
#    the License, or (at your option) any later version.
#
#    This program is distributed in the hope that it will be useful,
#    but WITHOUT ANY WARRANTY; without even the implied warranty of
#    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#    GNU General Public License for more details.
#
#    You should have received a copy of the GNU General Public License
#    along with this program; if not, write to the Free Software
#    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA     
#                                        02111-1307  USA
#
#  
########################### var_run Template File #############################

te_types="""
type TEMPLATETYPE_var_run_t;
files_pid_file(TEMPLATETYPE_var_run_t)
"""

te_rules="""
allow TEMPLATETYPE_t TEMPLATETYPE_var_run_t:file manage_file_perms;
allow TEMPLATETYPE_t TEMPLATETYPE_var_run_t:dir manage_dir_perms;
files_pid_filetrans(TEMPLATETYPE_t,TEMPLATETYPE_var_run_t, { file dir })
"""

te_stream_rules="""
allow TEMPLATETYPE_t TEMPLATETYPE_var_run_t:sock_file manage_file_perms;
files_pid_filetrans(TEMPLATETYPE_t,TEMPLATETYPE_var_run_t, sock_file)
"""

if_rules="""
########################################
## <summary>
##	Read TEMPLATETYPE PID files.
## </summary>
## <param name="domain">
##	<summary>
##	Domain allowed access.
##	</summary>
## </param>
#
interface(`TEMPLATETYPE_read_pid_files',`
	gen_require(`
		type TEMPLATETYPE_var_run_t;
	')

	files_search_pids($1)
	allow $1 TEMPLATETYPE_var_run_t:file r_file_perms;
')

"""

if_stream_rules="""\
########################################
## <summary>
##	Connect to TEMPLATETYPE over an unix stream socket.
## </summary>
## <param name="domain">
##	<summary>
##	Domain allowed access.
##	</summary>
## </param>
#
interface(`TEMPLATETYPE_stream_connect',`
	gen_require(`
		type TEMPLATETYPE_t, TEMPLATETYPE_var_run_t;
	')

	files_search_pids($1)
	allow $1 TEMPLATETYPE_var_run_t:sock_file write;
	allow $1 TEMPLATETYPE_t:unix_stream_socket connectto;
')
"""

fc_file="""\
FILENAME		--	gen_context(system_u:object_r:TEMPLATETYPE_var_run_t,s0)
"""

fc_sock_file="""\
FILENAME		-s	gen_context(system_u:object_r:TEMPLATETYPE_var_run_t,s0)
"""

fc_dir="""\
FILENAME(/.*)?			gen_context(system_u:object_r:TEMPLATETYPE_var_run_t,s0)
"""

